diff --git a/gcc/m2/gm2-compiler/SymbolTable.mod b/gcc/m2/gm2-compiler/SymbolTable.mod
index 8fed8b3fc5d..5ef71ea9bad 100644
--- a/gcc/m2/gm2-compiler/SymbolTable.mod
+++ b/gcc/m2/gm2-compiler/SymbolTable.mod
@@ -78,7 +78,7 @@ FROM SymbolKey IMPORT NulKey, SymbolTree, IsSymbol,
                       DoesTreeContainAny, ForeachNodeDo, ForeachNodeConditionDo,
                       NoOfNodes ;
 
-FROM M2Base IMPORT MixTypes, InitBase, Char, Integer, LongReal,
+FROM M2Base IMPORT MixTypes, MixTypesDecl, InitBase, Char, Integer, LongReal,
                    Cardinal, LongInt, LongCard, ZType, RType ;
 
 FROM M2System IMPORT Address ;
@@ -121,9 +121,12 @@ CONST
    UnboundedAddressName = "_m2_contents" ;
    UnboundedHighName    = "_m2_high_%d" ;
 
-   BreakSym             = 8496 ;
+   BreakSym             = 203 ;
 
 TYPE
+   ProcAnyBoolean = PROCEDURE (CARDINAL, ProcedureKind) : BOOLEAN ;
+   ProcAnyCardinal = PROCEDURE (CARDINAL, ProcedureKind) : CARDINAL ;
+
    ConstLitPoolEntry = POINTER TO RECORD
                                      sym      : CARDINAL ;
                                      tok      : CARDINAL ;
@@ -154,12 +157,6 @@ TYPE
               ModDeclared: CARDINAL ;
            END ;
 
-   ProcedureDecl = RECORD
-                      Forward,                (* The token locations for     *)
-                      Definition,             (* each potential procedure    *)
-                      Proper    : CARDINAL ;  (* declaration.                *)
-                   END ;
-
    VarDecl = RECORD
                 FullTok,
                 VarTok,
@@ -374,47 +371,34 @@ TYPE
                             NDim: CARDINAL ;  (* dimensions associated       *)
                          END ;
 
-   SymProcedure
+   ProcedureDeclaration
           = RECORD
-               name          : Name ;       (* Index into name array, name   *)
-                                            (* of procedure.                 *)
                ListOfParam   : List ;       (* Contains a list of all the    *)
                                             (* parameters in this procedure. *)
+               Defined       : BOOLEAN ;    (* Has the procedure been        *)
+                                            (* declared yet?                 *)
                ParamDefined  : BOOLEAN ;    (* Have the parameters been      *)
                                             (* defined yet?                  *)
-               DefinedInDef  : BOOLEAN ;    (* Were the parameters defined   *)
-                                            (* in the Definition module?     *)
-                                            (* Note that this depends on     *)
-                                            (* whether the compiler has read *)
-                                            (* the .def or .mod first.       *)
-                                            (* The second occurence is       *)
-                                            (* compared to the first.        *)
-               DefinedInImp  : BOOLEAN ;    (* Were the parameters defined   *)
-                                            (* in the Implementation module? *)
-                                            (* Note that this depends on     *)
-                                            (* whether the compiler has read *)
-                                            (* the .def or .mod first.       *)
-                                            (* The second occurence is       *)
-                                            (* compared to the first.        *)
-               DefinedByProper,             (* Were the parameters defined   *)
-               DefinedByForward,            (* by a FORWARD declaration?     *)
                HasVarArgs    : BOOLEAN ;    (* Does this procedure use ... ? *)
                HasOptArg     : BOOLEAN ;    (* Does this procedure use [ ] ? *)
-               OptArgInit    : CARDINAL ;   (* The optarg initial value.     *)
-               IsBuiltin     : BOOLEAN ;    (* Was it declared __BUILTIN__ ? *)
-               BuiltinName   : Name ;       (* name of equivalent builtin    *)
-               IsInline      : BOOLEAN ;    (* Was it declared __INLINE__ ?  *)
                IsNoReturn    : BOOLEAN ;    (* Attribute noreturn ?          *)
                ReturnOptional: BOOLEAN ;    (* Is the return value optional? *)
+               ReturnTypeTok,
+               ProcedureTok  : CARDINAL ;   (* Token pos of procedure name.  *)
+            END ;
+
+   SymProcedure
+          = RECORD
+               name          : Name ;       (* Index into name array, name   *)
+                                            (* of procedure.                 *)
+               Decl          : ARRAY ProcedureKind OF ProcedureDeclaration ;
+               OptArgInit    : CARDINAL ;   (* The optarg initial value.     *)
                IsExtern      : BOOLEAN ;    (* Make this procedure extern.   *)
                IsPublic      : BOOLEAN ;    (* Make this procedure visible.  *)
                IsCtor        : BOOLEAN ;    (* Is this procedure a ctor?     *)
                IsMonoName    : BOOLEAN ;    (* Ignores module name prefix.   *)
-               Declared      : ProcedureDecl ;  (* Forward, definition and   *)
-                                            (* proper token positions.       *)
-               DeclaredForward,             (* The token no used to define   *)
-               DeclaredDefinition,          (* the definition, proper and    *)
-               DeclaredProper: CARDINAL ;   (* forward.                      *)
+               BuildProcType : BOOLEAN ;    (* Are we building the           *)
+                                            (* associated proctype?          *)
                Unresolved    : SymbolTree ; (* All symbols currently         *)
                                             (* unresolved in this procedure. *)
                ScopeQuad     : CARDINAL ;   (* Index into quads for scope    *)
@@ -429,9 +413,9 @@ TYPE
                                             (* and restore interrupts?       *)
                ReturnType    : CARDINAL ;   (* Return type for function.     *)
                ProcedureType : CARDINAL ;   (* Proc type for this procedure. *)
-               Offset        : CARDINAL ;   (* Location of procedure used    *)
-                                            (* in Pass 2 and if procedure    *)
-                                            (* is a syscall.                 *)
+               IsBuiltin     : BOOLEAN ;    (* Was it declared __BUILTIN__ ? *)
+               BuiltinName   : Name ;       (* name of equivalent builtin    *)
+               IsInline      : BOOLEAN ;    (* Was it declared __INLINE__ ?  *)
                LocalSymbols: SymbolTree ;   (* Contains all symbols declared *)
                                             (* within this procedure.        *)
                EnumerationScopeList: List ;
@@ -467,6 +451,7 @@ TYPE
                OptArgInit    : CARDINAL ;   (* The optarg initial value.     *)
                ReturnType    : CARDINAL ;   (* Return type for function.     *)
                ReturnOptional: BOOLEAN ;    (* Is the return value optional? *)
+               ReturnTypeTok : CARDINAL ;   (* Token of return type.         *)
                Scope         : CARDINAL ;   (* Scope of declaration.         *)
                Size          : PtrToValue ; (* Runtime size of symbol.       *)
                TotalParamSize: PtrToValue ; (* size of all parameters.       *)
@@ -1564,7 +1549,7 @@ PROCEDURE IsError (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=ErrorSym )
 END IsError ;
@@ -1599,7 +1584,7 @@ PROCEDURE IsTuple (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=TupleSym )
 END IsTuple ;
@@ -1613,7 +1598,7 @@ PROCEDURE IsObject (Sym: CARDINAL) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal(Sym) ;
+   AssertInRange(Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN( pSym^.SymbolType=ObjectSym )
 END IsObject ;
@@ -3940,15 +3925,23 @@ END PutModuleCtorExtern ;
 
 
 (*
-   InitProcedureDecl - initializes all fields of ProcedureDecl to UnknownTokenNo.
+   InitProcedureDeclaration - initialize all the ProcedureDeclaration
+                              fields.
 *)
 
-PROCEDURE InitProcedureDecl (VAR decl: ProcedureDecl) ;
+PROCEDURE InitProcedureDeclaration (VAR decl: ProcedureDeclaration) ;
 BEGIN
-   decl.Forward := UnknownTokenNo ;
-   decl.Definition := UnknownTokenNo ;
-   decl.Proper := UnknownTokenNo
-END InitProcedureDecl ;
+   WITH decl DO
+      Defined := FALSE ;           (* Has the procedure been        *)
+                                   (* declared yet?                 *)
+      ParamDefined := FALSE ;      (* Have the parameters been      *)
+                                   (* defined yet?                  *)
+      HasVarArgs := FALSE ;        (* Does the procedure use ... ?  *)
+      HasOptArg := FALSE ;         (* Does this procedure use [ ] ? *)
+      IsNoReturn := FALSE ;        (* Declared attribute noreturn ? *)
+      ReturnOptional := FALSE      (* Is the return value optional? *)
+   END
+END InitProcedureDeclaration ;
 
 
 (*
@@ -3960,9 +3953,14 @@ PROCEDURE MakeProcedure (tok: CARDINAL; ProcedureName: Name) : CARDINAL ;
 VAR
    pSym: PtrToSymbol ;
    Sym : CARDINAL ;
+   kind: ProcedureKind ;
 BEGIN
    tok := CheckTok (tok, 'procedure') ;
    Sym := DeclareSym(tok, ProcedureName) ;
+   IF Sym = BreakSym
+   THEN
+      stop
+   END ;
    IF NOT IsError(Sym)
    THEN
       pSym := GetPsym(Sym) ;
@@ -3970,43 +3968,18 @@ BEGIN
          SymbolType := ProcedureSym ;
          WITH Procedure DO
             name := ProcedureName ;
-            InitList(ListOfParam) ;      (* Contains a list of all the    *)
-                                         (* parameters in this procedure. *)
-            ParamDefined := FALSE ;      (* Have the parameters been      *)
-                                         (* defined yet?                  *)
-            DefinedInDef := FALSE ;      (* Were the parameters defined   *)
-                                         (* in the Definition module?     *)
-                                         (* Note that this depends on     *)
-                                         (* whether the compiler has read *)
-                                         (* the .def or .mod first.       *)
-                                         (* The second occurence is       *)
-                                         (* compared to the first.        *)
-            DefinedInImp := FALSE ;      (* Were the parameters defined   *)
-                                         (* in the Implementation module? *)
-                                         (* Note that this depends on     *)
-                                         (* whether the compiler has read *)
-                                         (* the .def or .mod first.       *)
-                                         (* The second occurence is       *)
-                                         (* compared to the first.        *)
-            DefinedByProper := FALSE ;   (* Were the parameters defined   *)
-                                         (* in a proper procedure.        *)
-            DefinedByForward := FALSE ;  (* Were the parameters defined   *)
-                                         (* in a FORWARD declaration?     *)
-            HasVarArgs := FALSE ;        (* Does the procedure use ... ?  *)
-            HasOptArg := FALSE ;         (* Does this procedure use [ ] ? *)
-            OptArgInit := NulSym ;       (* The optarg initial value.     *)
-            IsBuiltin := FALSE ;         (* Was it declared __BUILTIN__ ? *)
-            BuiltinName := NulName ;     (* name of equivalent builtin    *)
-            IsInline := FALSE ;          (* Was is declared __INLINE__ ?  *)
-            IsNoReturn := FALSE ;        (* Declared attribute noreturn ? *)
-            ReturnOptional := FALSE ;    (* Is the return value optional? *)
+            FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+               InitProcedureDeclaration (Decl[kind]) ;
+               InitList (Decl[kind].ListOfParam)
+            END ;
+            OptArgInit := NulSym ;       (* The optional arg default      *)
+                                         (* value.                        *)
             IsExtern := FALSE ;          (* Make this procedure external. *)
             IsPublic := FALSE ;          (* Make this procedure visible.  *)
             IsCtor := FALSE ;            (* Is this procedure a ctor?     *)
             IsMonoName := FALSE ;        (* Overrides module name prefix. *)
-            InitProcedureDecl (Declared) ; (* The token no used to define *)
-                                         (* the definition, proper and    *)
-                                         (* forward.                      *)
+            BuildProcType := TRUE ;      (* Are we building the           *)
+                                         (* proctype associated with sym? *)
             Scope := GetCurrentScope() ; (* Scope of procedure.           *)
             InitTree(Unresolved) ;       (* All symbols currently         *)
                                          (* unresolved in this procedure. *)
@@ -4020,7 +3993,6 @@ BEGIN
             ReturnType := NulSym ;       (* Not a function yet!           *)
                                          (* The ProcType equivalent.      *)
             ProcedureType := MakeProcType (tok, NulName) ;
-            Offset := 0 ;                (* Location of procedure.        *)
             InitTree(LocalSymbols) ;
             InitList(EnumerationScopeList) ;
                                          (* Enumeration scope list which  *)
@@ -4036,6 +4008,9 @@ BEGIN
             InitList(ListOfModules) ;    (* List of all inner modules.    *)
             ExceptionFinally := FALSE ;  (* does it have an exception?    *)
             ExceptionBlock := FALSE ;    (* does it have an exception?    *)
+            IsBuiltin := FALSE ;         (* Was it declared __BUILTIN__ ? *)
+            BuiltinName := NulName ;     (* name of equivalent builtin    *)
+            IsInline := FALSE ;          (* Was is declared __INLINE__ ?  *)
             Size := InitValue() ;        (* Activation record size.       *)
             TotalParamSize
                        := InitValue() ;  (* size of all parameters.       *)
@@ -4058,7 +4033,8 @@ END MakeProcedure ;
                           field of procedure sym.
 *)
 
-PROCEDURE PutProcedureNoReturn (Sym: CARDINAL; value: BOOLEAN) ;
+PROCEDURE PutProcedureNoReturn (Sym: CARDINAL; kind: ProcedureKind;
+                                value: BOOLEAN) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
@@ -4066,7 +4042,7 @@ BEGIN
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ProcedureSym: Procedure.IsNoReturn := value
+      ProcedureSym: Procedure.Decl[kind].IsNoReturn := value
 
       ELSE
          InternalError ('expecting ProcedureSym symbol')
@@ -4079,7 +4055,7 @@ END PutProcedureNoReturn ;
    IsProcedureNoReturn - returns TRUE if this procedure never returns.
 *)
 
-PROCEDURE IsProcedureNoReturn (Sym: CARDINAL) : BOOLEAN ;
+PROCEDURE IsProcedureNoReturn (Sym: CARDINAL; kind: ProcedureKind) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
@@ -4087,7 +4063,7 @@ BEGIN
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ProcedureSym: RETURN Procedure.IsNoReturn
+      ProcedureSym: RETURN Procedure.Decl[kind].IsNoReturn
 
       ELSE
          InternalError ('expecting ProcedureSym symbol')
@@ -6899,22 +6875,24 @@ END GetNth ;
    GetNthParam - returns the n th parameter of a procedure Sym.
 *)
 
-PROCEDURE GetNthParam (Sym: CARDINAL; ParamNo: CARDINAL) : CARDINAL ;
+PROCEDURE GetNthParam (Sym: CARDINAL; kind: ProcedureKind;
+                       ParamNo: CARDINAL) : CARDINAL ;
 VAR
    pSym: PtrToSymbol ;
    i   : CARDINAL ;
 BEGIN
    IF ParamNo=0
    THEN
-      (* Demands the return type of the function *)
+      (* The return type of the function *)
       i := GetType(Sym)
    ELSE
       pSym := GetPsym(Sym) ;
       WITH pSym^ DO
          CASE SymbolType OF
 
-         ProcedureSym: i := GetItemFromList(Procedure.ListOfParam, ParamNo) |
-         ProcTypeSym : i := GetItemFromList(ProcType.ListOfParam, ParamNo)
+         ProcedureSym: i := GetItemFromList (Procedure.Decl[kind].ListOfParam,
+                                             ParamNo) |
+         ProcTypeSym : i := GetItemFromList (ProcType.ListOfParam, ParamNo)
 
          ELSE
             InternalError ('expecting ProcedureSym or ProcTypeSym')
@@ -6925,6 +6903,26 @@ BEGIN
 END GetNthParam ;
 
 
+(*
+   GetNthParamAny - returns the nth parameter from the order
+                    proper procedure, forward declaration
+                    or definition module procedure.
+*)
+
+PROCEDURE GetNthParamAny (sym: CARDINAL; ParamNo: CARDINAL) : CARDINAL ;
+VAR
+   kind: ProcedureKind ;
+BEGIN
+   FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+      IF GetProcedureParametersDefined (sym, kind)
+      THEN
+         RETURN GetNthParam (sym, kind, ParamNo)
+      END
+   END ;
+   InternalError ('no procedure kind exists')
+END GetNthParamAny ;
+
+
 (*
    The Following procedures fill in the symbol table with the
    symbol entities.
@@ -8165,7 +8163,7 @@ BEGIN
             InternalError ('expecting a Var symbol')
          END
       END ;
-      t := MixTypes(GetType(e1), GetType(e2), tok) ;
+      t := MixTypesDecl (e1, e2, GetType(e1), GetType(e2), tok) ;
       IF t#NulSym
       THEN
          Assert(NOT IsConstructor(t)) ;
@@ -8300,23 +8298,23 @@ PROCEDURE IsUnknown (Sym: WORD) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
-   CheckLegal (Sym) ;
+   AssertInRange (Sym) ;
    pSym := GetPsym(Sym) ;
    RETURN pSym^.SymbolType=UndefinedSym
 END IsUnknown ;
 
 
 (*
-   CheckLegal - determines whether the Sym is a legal symbol.
+   AssertInRange - determines whether the Sym is a legal symbol.
 *)
 
-PROCEDURE CheckLegal (Sym: CARDINAL) ;
+PROCEDURE AssertInRange (Sym: CARDINAL) ;
 BEGIN
    IF (Sym<1) OR (Sym>FinalSymbol())
    THEN
       InternalError ('illegal symbol')
    END
-END CheckLegal ;
+END AssertInRange ;
 
 
 (*
@@ -9375,25 +9373,29 @@ END ForeachLocalSymDo ;
 
 
 (*
-   ForeachParamSymDo - foreach parameter symbol in procedure, Sym,
-                       perform the procedure, P.  Each symbol
+   ForeachParamSymDo - foreach parameter symbol in procedure Sym
+                       perform the procedure P.  Each symbol
                        looked up will be VarParam or Param
-                       (not the shadow variable).
+                       (not the shadow variable).  Every parameter
+                       from each KindProcedure is iterated over.
 *)
 
 PROCEDURE ForeachParamSymDo (Sym: CARDINAL; P: PerformOperation) ;
 VAR
+   kind : ProcedureKind ;
    param: CARDINAL ;
    p, i : CARDINAL ;
 BEGIN
    IF IsProcedure (Sym)
    THEN
-      p := NoOfParam (Sym) ;
-      i := p ;
-      WHILE i>0 DO
-         param := GetNthParam (Sym, i) ;
-         P (param) ;
-         DEC(i)
+      FOR kind := MIN (ProcedureKind) TO MAX (ProcedureKind) DO
+         p := NoOfParam (Sym, kind) ;
+         i := p ;
+         WHILE i>0 DO
+            param := GetNthParam (Sym, kind, i) ;
+            P (param) ;
+            DEC(i)
+         END
       END
    END
 END ForeachParamSymDo ;
@@ -10339,7 +10341,7 @@ END IsType ;
                       optional.
 *)
 
-PROCEDURE IsReturnOptional (sym: CARDINAL) : BOOLEAN ;
+PROCEDURE IsReturnOptional (sym: CARDINAL; kind: ProcedureKind) : BOOLEAN ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
@@ -10347,7 +10349,7 @@ BEGIN
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ProcedureSym: RETURN( Procedure.ReturnOptional ) |
+      ProcedureSym: RETURN( Procedure.Decl[kind].ReturnOptional ) |
       ProcTypeSym : RETURN( ProcType.ReturnOptional )
 
       ELSE
@@ -10358,11 +10360,12 @@ END IsReturnOptional ;
 
 
 (*
-   SetReturnOptional - sets the ReturnOptional field in the Procedure or
+   SetReturnOptional - sets the ReturnOptional field in the Procedure:kind or
                        ProcType symboltable entry.
 *)
 
-PROCEDURE SetReturnOptional (sym: CARDINAL; isopt: BOOLEAN) ;
+PROCEDURE SetReturnOptional (sym: CARDINAL; kind: ProcedureKind;
+                             isopt: BOOLEAN) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
@@ -10370,7 +10373,7 @@ BEGIN
    WITH pSym^ DO
       CASE SymbolType OF
 
-      ProcedureSym: Procedure.ReturnOptional := isopt |
+      ProcedureSym: Procedure.Decl[kind].ReturnOptional := isopt |
       ProcTypeSym : ProcType.ReturnOptional := isopt
 
       ELSE
@@ -10381,44 +10384,34 @@ END SetReturnOptional ;
 
 
 (*
-   CheckOptFunction - checks to see whether the optional return value
-                      has been set before and if it differs it will
-                      generate an error message.  It will set the
-                      new value to, isopt.
+   IsReturnOptionalAny - returns TRUE if the return value for sym is
+                         optional.
 *)
 
-PROCEDURE CheckOptFunction (sym: CARDINAL; isopt: BOOLEAN) ;
+PROCEDURE IsReturnOptionalAny (sym: CARDINAL) : BOOLEAN ;
 VAR
-   n: Name ;
-   e: Error ;
+   pSym: PtrToSymbol ;
 BEGIN
-   IF GetType(sym)#NulSym
-   THEN
-      IF IsReturnOptional(sym) AND (NOT isopt)
-      THEN
-         n := GetSymName(sym) ;
-         e := NewError(GetTokenNo()) ;
-         ErrorFormat1(e, 'function (%a) has no optional return value here', n) ;
-         e := ChainError(GetDeclaredMod(sym), e) ;
-         ErrorFormat1(e, 'whereas the same function (%a) was declared to have an optional return value at this point', n)
-      ELSIF (NOT IsReturnOptional(sym)) AND isopt
-      THEN
-         n := GetSymName(sym) ;
-         e := NewError(GetTokenNo()) ;
-         ErrorFormat1(e, 'function (%a) has an optional return value', n) ;
-         e := ChainError(GetDeclaredMod(sym), e) ;
-         ErrorFormat1(e, 'whereas the same function (%a) was declared to have no optional return value at this point', n)
+   pSym := GetPsym(sym) ;
+   WITH pSym^ DO
+      CASE SymbolType OF
+
+      ProcedureSym: RETURN IsProcedureAnyBoolean (sym, IsReturnOptional) |
+      ProcTypeSym : RETURN ProcType.ReturnOptional
+
+      ELSE
+         InternalError ('expecting a Procedure or ProcType symbol')
       END
-   END ;
-   SetReturnOptional(sym, isopt)
-END CheckOptFunction ;
+   END
+END IsReturnOptionalAny ;
 
 
 (*
    PutFunction - Places a TypeSym as the return type to a procedure Sym.
 *)
 
-PROCEDURE PutFunction (Sym: CARDINAL; TypeSym: CARDINAL) ;
+PROCEDURE PutFunction (tok: CARDINAL; Sym: CARDINAL; kind: ProcedureKind;
+                       TypeSym: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
@@ -10427,11 +10420,11 @@ BEGIN
       CASE SymbolType OF
 
       ErrorSym: |
-      ProcedureSym: CheckOptFunction(Sym, FALSE) ;
-                    Procedure.ReturnType := TypeSym ;
-                    PutFunction (Procedure.ProcedureType, TypeSym) |
-      ProcTypeSym : CheckOptFunction(Sym, FALSE) ;
-                    ProcType.ReturnType := TypeSym
+      ProcedureSym: Procedure.ReturnType := TypeSym ;
+                    Procedure.Decl[kind].ReturnTypeTok := tok ;
+                    PutFunction (tok, Procedure.ProcedureType, kind, TypeSym) |
+      ProcTypeSym : ProcType.ReturnType := TypeSym ;
+                    ProcType.ReturnTypeTok := tok ;
 
       ELSE
          InternalError ('expecting a Procedure or ProcType symbol')
@@ -10444,7 +10437,7 @@ END PutFunction ;
    PutOptFunction - places a TypeSym as the optional return type to a procedure Sym.
 *)
 
-PROCEDURE PutOptFunction (Sym: CARDINAL; TypeSym: CARDINAL) ;
+PROCEDURE PutOptFunction (tok: CARDINAL; Sym: CARDINAL; kind: ProcedureKind; TypeSym: CARDINAL) ;
 VAR
    pSym: PtrToSymbol ;
 BEGIN
@@ -10453,11 +10446,12 @@ BEGIN
       CASE SymbolType OF
 
       ErrorSym: |
-      ProcedureSym: CheckOptFunction (Sym, TRUE) ;
-                    Procedure.ReturnType := TypeSym ;
-                    PutOptFunction (Procedure.ProcedureType, TypeSym) |
-      ProcTypeSym : CheckOptFunction (Sym, TRUE) ;
-                    ProcType.ReturnType := TypeSym
+      ProcedureSym: Procedure.ReturnType := TypeSym ;
+                    Procedure.Decl[kind].ReturnOptional := TRUE ;
+                    Procedure.Decl[kind].ReturnTypeTok := tok ;
+                    PutOptFunction (tok, Procedure.ProcedureType, kind, TypeSym) |
+      ProcTypeSym : ProcType.ReturnType := TypeSym ;
+                    ProcType.ReturnTypeTok := tok ;
 
       ELSE
          InternalError ('expecting a Procedure or ProcType symbol')
@@ -10473,7 +10467,9 @@ END PutOptFunction ;
 PROCEDURE MakeVariableForParam (tok      : CARDINAL;
                                 ParamName: Name;
                                 ProcSym  : CARDINAL;
+                                kind     : ProcedureKind;
                                 no       : CARDINAL;
+                                ParmType : CARDINAL;
                                 typetok  : CARDINAL) : CARDINAL ;
 VAR
    pSym       : PtrToSymbol ;
@@ -10493,14 +10489,14 @@ BEGIN
       END
    END ;
    (* Note that the parameter is now treated as a local variable.  *)
-   PutVarTok (VariableSym, GetType(GetNthParam(ProcSym, no)), typetok) ;
+   PutVarTok (VariableSym, ParmType, typetok) ;
    PutDeclared (tok, VariableSym) ;
    (*
       Normal VAR parameters have LeftValue,
       however Unbounded VAR parameters have RightValue.
       Non VAR parameters always have RightValue.
    *)
-   IF IsVarParam (ProcSym, no) AND (NOT IsUnboundedParam (ProcSym, no))
+   IF IsVarParam (ProcSym, kind, no) AND (NOT IsUnboundedParam (ProcSym, kind, no))
    THEN
       PutMode (VariableSym, LeftValue)
    ELSE
@@ -10512,13 +10508,14 @@ END MakeVariableForParam ;
 
 (*
    PutParam - Places a Non VAR parameter ParamName with type ParamType into
-              procedure Sym. The parameter number is ParamNo.
+              procedure Sym:kind.  The parameter number is ParamNo.
               If the procedure Sym already has this parameter then
               the parameter is checked for consistancy and the
               consistancy test is returned.
 *)
 
-PROCEDURE PutParam (tok: CARDINAL; Sym: CARDINAL; ParamNo: CARDINAL;
+PROCEDURE PutParam (tok: CARDINAL; Sym: CARDINAL;
+                    kind: ProcedureKind; ParamNo: CARDINAL;
                     ParamName: Name; ParamType: CARDINAL;
                     isUnbounded: BOOLEAN; typetok: CARDINAL) : BOOLEAN ;
 VAR
@@ -10526,8 +10523,9 @@ VAR
    ParSym     : CARDINAL ;
    VariableSym: CARDINAL ;
 BEGIN
-   IF ParamNo<=NoOfParam(Sym)
+   IF GetProcedureParametersDefined (Sym, kind)
    THEN
+      (* ParamNo <= NoOfParamAny (Sym) *)
       InternalError ('why are we trying to put parameters again')
    ELSE
       (* Add a new parameter *)
@@ -10543,11 +10541,14 @@ BEGIN
             InitWhereDeclaredTok(tok, At)
          END
       END ;
-      AddParameter(Sym, ParSym) ;
-      IF ParamName#NulName
+      AddParameter (Sym, kind, ParSym) ;
+      (* Only declare a parameter as a local variable if it has not been done before.
+         It might be declared during the definition module, forward declaration or
+         proper procedure.  Name mismatches are checked in P2SymBuild.mod.  *)
+      IF (ParamName # NulName) AND (GetNth (Sym, ParamNo) = NulSym)
       THEN
-         VariableSym := MakeVariableForParam(tok, ParamName, Sym,
-                                             ParamNo, typetok) ;
+         VariableSym := MakeVariableForParam (tok, ParamName, Sym, kind,
+                                              ParamNo, ParamType, typetok) ;
          IF VariableSym=NulSym
          THEN
             RETURN( FALSE )
@@ -10564,14 +10565,15 @@ END PutParam ;
 
 (*
    PutVarParam - Places a Non VAR parameter ParamName with type
-                 ParamType into procedure Sym.
+                 ParamType into procedure Sym:kind.
                  The parameter number is ParamNo.
                  If the procedure Sym already has this parameter then
                  the parameter is checked for consistancy and the
                  consistancy test is returned.
 *)
 
-PROCEDURE PutVarParam (tok: CARDINAL; Sym: CARDINAL; ParamNo: CARDINAL;
+PROCEDURE PutVarParam (tok: CARDINAL; Sym: CARDINAL; kind: ProcedureKind;
+                       ParamNo: CARDINAL;
                        ParamName: Name; ParamType: CARDINAL;
                        isUnbounded: BOOLEAN; typetok: CARDINAL) : BOOLEAN ;
 VAR
@@ -10579,7 +10581,7 @@ VAR
    ParSym     : CARDINAL ;
    VariableSym: CARDINAL ;
 BEGIN
-   IF ParamNo<=NoOfParam(Sym)
+   IF GetProcedureParametersDefined (Sym, kind)
    THEN
       InternalError ('why are we trying to put parameters again')
    ELSE
@@ -10597,11 +10599,14 @@ BEGIN
             InitWhereDeclaredTok(tok, At)
          END
       END ;
-      AddParameter(Sym, ParSym) ;
-      IF ParamName#NulName
+      AddParameter (Sym, kind, ParSym) ;
+      (* Only declare a parameter as a local variable if it has not been done before.
+         It might be declared during the definition module, forward declaration or
+         proper procedure.  Name mismatches are checked in P2SymBuild.mod.  *)
+      IF (ParamName # NulName) AND (GetNth (Sym, ParamNo) = NulSym)
       THEN
-         VariableSym := MakeVariableForParam(tok, ParamName, Sym,
-                                             ParamNo, typetok) ;
+         VariableSym := MakeVariableForParam (tok, ParamName, Sym, kind,
+                                              ParamNo, ParamType, typetok) ;
          IF VariableSym=NulSym
          THEN
             RETURN( FALSE )
@@ -10610,19 +10615,19 @@ BEGIN
             pSym^.VarParam.ShadowVar := VariableSym
          END
       END ;
-      AddProcedureProcTypeParam (Sym, ParamType, isUnbounded, TRUE) ;
-      RETURN( TRUE )
-   END
+      AddProcedureProcTypeParam (Sym, ParamType, isUnbounded, TRUE)
+   END ;
+   RETURN( TRUE )
 END PutVarParam ;
 
 
 (*
-   PutParamName - assigns a name, name, to paramater, no, of procedure,
-                  ProcSym.
+   PutParamName - assigns a name to paramater no of procedure ProcSym:kind.
 *)
 
-PROCEDURE PutParamName (tok: CARDINAL; ProcSym: CARDINAL; no: CARDINAL;
-                        name: Name; typetok: CARDINAL) ;
+PROCEDURE PutParamName (tok: CARDINAL; ProcSym: CARDINAL; kind: ProcedureKind;
+                        no: CARDINAL;
+                        name: Name; ParamType: CARDINAL; typetok: CARDINAL) ;
 VAR
    pSym  : PtrToSymbol ;
    ParSym: CARDINAL ;
@@ -10633,7 +10638,8 @@ BEGIN
       CASE SymbolType OF
 
       ErrorSym    : RETURN |
-      ProcedureSym: ParSym := GetItemFromList(Procedure.ListOfParam, no) |
+      ProcedureSym: ParSym := GetItemFromList(Procedure.Decl[kind].ListOfParam,
+                                              no) |
       ProcTypeSym : ParSym := GetItemFromList(ProcType.ListOfParam, no)
 
       ELSE
